var WxParse = require('../../../utils/wxParse/wxParse.js');

const app = getApp();
let self = null;
let content_privacy = `<div>
            <p class="tac font16"><b>隐私政策</b><br /><br /></div>
            <div>美得得（以下或称“我们”）将按法律法规要求，采取相应安全报货措施，尽力保护您的个人信息安全可控。有鉴于此，我们制定本《隐私政策》（下称“本政策”）并提醒你： </div>
            <div>本政策适用于美得得产品及服务。如我们关联公司的产品或服务中使用了美得得提供的产品或服务但未设独立的隐私政策的，则本政策同样适用于该部分产品或服务。 </div>
            <div>需要特别说明的是，<strong><u>本隐私政策不适用于其他第三方通过前述网页或客户端或者小程序或公众号等向您提供服务。例如您通过美得得使用第三方应用或者服务，或第三方服务和产品依托美得得产品向您提供服务时，您向第三方提供的信息不适用本政策。</u></strong><strong><u> </u></strong></div>
            <div>在使用美得得产品或服务前，请您务必仔细查阅并透彻理解本政策，再确认充分理解并同意后使用相关产品或服务，如您对本隐私政策有任何疑问，您可以通过我们公布的联系方式与我们联系。<strong><u>一旦您开始使用美得得产品或服务，即表示您已同意我们按照本隐私政策来收集、处理、存储、使用、共享和保护您的个人信息。</u></strong><strong><u> </u></strong></div>
            <div>第一部分定义</div>
            <div>个人信息：指以电子或者其他方式记录的能够单独或者与其他信息结合识别特定自然人身份或者反映特定自然人活动情况的各种信息。</div>
            <div>个人敏感信息：包括身份证件号码、手机号码、个人生物识别信息、银行账号、财产信息、行踪轨迹、交易信息、14岁以下（含）儿童的个人信息等。</div>
            <div>个人信息删除：指在实现日常业务功能所涉及的系统中去除个人信息的行为，使其保持不可被检索、访问的状态。</div>
            <div>第二部分 隐私政策 <br />
                1、我们如何收集和使用您的个人信息； <br />
                2、我们如何使用 Cookie 和同类技术； <br />
                3、我们如何共享、转让、公开披露您的个人信息； <br />
                4、我们如何保护您的个人信息； <br />
                5、您如何行使您的个人信息权利； <br />
                6、我们如何处理儿童的个人信息； <br />
                7、您的个人信息如何在全球范围转移； <br />
                8、本政策如何更新； <br />
                9、如何联系我们。 </div>
            <div>一、我们如何收集和使用您的个人信息 <br />
                我们会出于本政策所述的以下目的，收集和使用您的个人信息： </div>
            <div>（一）提供账号服务 <br />
                为了遵守法律法规的要求，以及向您提供更个性化、更便捷的服务，我们需要识别您的身份，<strong><u>当您注册我们的账户及您在使用我们的相关服务时，需要您授权您的微信或微博等第三方账号的ID及头像和昵称，您需要填写、提交及/或以其他任何方式提供您的个人信息，包括但不限于您的姓名、性别、出生年月日、身份证号码、电话号码、电子邮箱、收货地址及相关附加信息（如您地址中的所在省份和城市、邮政编码等）、银行账户或其他支付工具的账户信息等。</u></strong>如果您仅需使用浏览、搜索等基本服务，您不需要注册成为我们的账号及提供上述信息。如您不提供真实姓名、性别、出生年月日、身份证号码、电话号码、电子邮箱也不影响您使用美得得的服务进行基本浏览、搜索、购买功能等服务。 </div>
            <div>（二）为您展示或推送商品或服务 <br />
                <strong><u>为给您提供更好的交易服务，我们会根据您的浏览及搜索记录、设备信息、位置信息、订单信息、及可能的个人身份信息，提取您的浏览、搜索偏好、行为习惯、位置信息等特征，基于特征标签进行间接人群画像并展示、推送信息。</u></strong>如您不想接受我们给您发送的商业广告，您可通过短信提示回复退订或我们提供的其他方式进行退订。 </div>
            <div>（三）向您提供商品或服务 <br />
                <strong><u>1、您向我们提供的信息</u></strong><strong><u> </u></strong><br />
                <strong><u>为便于向您提供我们的产品或服务，我们会记录您提供的收货人姓名、收货地址、邮政编码、收货人联系电话。为完成交易，我们将搜集您的支付信息，以便我们了解您的支付状态。</u></strong><strong><u> </u></strong><br />
                   
                您可以通过美得得为其他人订购商品或服务或要求其他人帮您付款，您需要提供该实际订购人的前述个人信息或提供代付人的支付信息或手机号码。向美得得提供这些个人信息之前，您需确保您已经取得其授权同意。 <br />
                <strong>2、我们在您使用服务过程中收集的信息</strong><strong> </strong><br />
                      
                为向您提供更契合您需求的页面展示和搜索结果、了解产品适配性、识别账户异常状态，我们会收集关于您使用的服务以及使用方式的信息并将这些信息进行关联，这些信息包括： <br />
                     
                设备信息：我们会根据您在软件安装及使用中授予的具体权限，接收并记录您所使用的设备相关信息（例如设备型号、操作系统版本等软硬件特征和设备环境信息）、设备所在位置相关信息（例如IP 地址、GPS位置以及能够提供相关信息的Wi-Fi 接入点、蓝牙和基站等传感器信息）。 <br />
                      
                日志信息：当您使用我们的网站或客户端提供的产品或服务时，我们会自动收集您对我们服务的详细使用情况，作为有关网络日志保存。例如您的IP地址、浏览器的类型、电信运营商、使用的语言、访问日期和时间及您访问的网页记录等。 <br />
                <strong><u>请注意，单独的设备信息、日志信息等是无法识别特定自然人身份的信息。</u></strong>如果我们将这类非个人信息与其他信息结合用于识别特定自然人身份，或者将其与个人信息结合使用，则在结合使用期间，这类非个人信息将被视为个人信息，除取得您授权或法律法规另有规定外，我们会将该类个人信息做匿名化、去标识化处理。 <br />
                为展示您账户的订单信息，我们会收集您在使用我们服务过程中产生的订单信息用于向您展示及便于您对订单进行管理。 <br />
                <strong><u>当您与我们联系时，我们可能会保存您的通信/通话记录和内容或您留下的联系方式等信息，以便与您联系或帮助您解决问题，或记录相关问题的处理方案及结果。</u></strong><strong><u> </u></strong><br />
                <strong>3、我们通过间接获得方式收集到的您的个人信息</strong><strong> </strong><br />
                为确认交易状态及为您提供售后与争议解决服务，我们会通过您基于交易所选择的交易对象、交易方式、支付机构、物流公司等收集与交易进度相关的您的交易、支付、物流信息，或将您的交易信息共享给上述服务提供者。 <br />
                您可通过我们提供的链接入口使用美得得账户登录我们关联公司或者合作公司提供的产品或服务，包括来自微信、微博、快手、小程序等的信息。 <br />
                <strong><u>您在使用第三方服务时，可以直接使用第三方服务时直接跳转到我们提供服务的页面，如您进行了除浏览以外的行为，我们将可能收集到您的个人信息（包括您在第三账号的ID、头像、昵称等）。</u></strong><strong><u> </u></strong></div>
            <div>（四）为您提供安全保障 <br />
                为提高您使用我们及我们关联公司、合作伙伴提供服务的安全性，保护您或其他用户或公众的人身财产安全免遭侵害，<strong><u>我们可能使用或整合您的个人信息、交易信息、设备信息、有关网络日志以及我们关联公司、合作伙伴取得您授权或依据法律共享的信息，来综合判断您账户及交易风险、进行身份验证、检测及防范安全事件，并依法采取必要的记录、审计、分析、处置措施。</u></strong><strong><u> </u></strong></div>
            <div>（五）其他用途 <br />
                我们将信息用于本政策未载明的其他用途，或者将基于特定目的收集而来的信息用于其他目的时，会事先征求您的同意。 <br />
                （六）征得授权同意的例外 <br />
                根据相关法律法规规定，以下情形中收集您的个人信息无需征得您的授权同意： <br />
                1、根据法律法规的规定或行政、司法机构等有权机关的要求或者授权； <br />
                2、您出现违反适用法律、法规规定或者违反您与我们签署的相关协议（包括在线签署的电子协议）或相关规则时需要向第三方披露的情形。 <br />
                3、我们与第三方进行联合营销活动，我们可能与其共享活动过程中产生的、为完成活动所必要的个人信息，如参加活动的用户数、中奖名单、中奖人联系方式等，以便第三方能及时向您发放奖品。如与授权合作伙伴共享，仅为实现本政策中声明的目的，我们的某些服务将由授权合作伙伴提供。我们可能会与合作伙伴共享您的某些个人信息，以提供更好的客户服务和用户体验。例如，在您使用我们配送服务时，我们必须与物流服务提供商共享您的个人信息才能安排送货，或者安排合作伙伴提供服务。我们仅会出于合法、正当、必要、特定、明确的目的共享您的个人信息，并且只会共享提供服务所必要的个人信息。我们的合作伙伴无权将共享的个人信息用于任何其他用途； <br />
                4、为维护我们及关联方或其他我们用户的合法权益； <br />
                5、从合法公开披露的信息中收集个人信息的，如合法的新闻报道、政府信息公开等渠道； <br />
                6、出于实现本政策公示的我们如何使用您的个人信息的目的，或为履行我们和您签订的协议中或本隐私政策中的义务和行使我们的权利，向我们的关联方、合作伙伴或代表我们履行某项职能的第三方（例如处理银行卡的支付机构等）分享您的个人信息。； <br />
                7、法律法规规定的其他情形。 <br />
                如我们停止运营美得得产品或服务，我们将及时停止继续收集您个人信息的活动，将停止运营的通知以逐一送达或公告的形式通知您，对所持有的个人信息进行删除或匿名化处理。 </div>
            <div>二、我们如何使用 Cookie 和同类技术 <br />
                （一）Cookie的使用 <br />
                为确保网站正常运转、为您获得更轻松的访问体验、向您推荐您可能感兴趣的内容，我们会在您的计算机或移动设备上存储名Cookie、Flash Cookie或浏览器或关联应用程序提供的其他通常包含标识符、站点名称以及一些号码和字符的本地存储（统称“Cookie”）。借助于 Cookie，网站能够存储您的偏好或购物车内的商品等数据。 <br />
                如果您的浏览器或浏览器附加服务允许，您可修改对Cookie的接受程度或拒绝我们的Cookie。但如果您这么做，在某些情况下可能会影响您安全访问我们的网站，而无法使用部分我们提供的服务。 <br />
                （二）网站信标和像素标签 <br />
                除Cookie 外，我们还会在网站上使用网站信标和像素标签等其他同类技术。例如，我们向您发送的电子邮件可能含有链接至我们网站内容的地址链接，如果您点击该链接，我们则会跟踪此次点击，帮助我们了解您的产品或服务偏好以便于我们主动改善客户服务体验。网站信标通常是一种嵌入到网站或电子邮件中的透明图像。借助于电子邮件中的像素标签，我们能够获知电子邮件是否被打开。如果您不希望自己的活动以这种方式被追踪，则可以随时从我们的寄信名单中退订。 </div>
            <div>三、我们如何共享、转让、公开披露您的个人信息 <br />
                （一）共享 <br />
                我们不会与美得得服务提供者以外的公司、组织和个人共享您的个人信息，但以下情况除外： <br />
                1、在您主动选择情况下共享：若您主动通过美得得购买商品和服务，我们会根据您的选择，将您的订单信息与交易有关的必要信息与相关商品和服务的提供者共享来实现您向其购买商品或服务的需求，并促使其可以完成后续的售后服务。您可以在相关商品和服务的提供者从事经营活动的主页面查询其营业执照登载的信息，以辨别您的交易对象身份。 <br />
                2、在获取明确同意情况下共享：获得您的明确同意后，我们会与其他方共享您的个人信息。例如，如果我们委托第三方向您提供产品或服务时，我们会在征得您同意后将上述信息共享给第三方，如果您拒绝提供此类信息，我们将无法完成相关交付服务。 <br />
                3、在法定情形下共享：我们可能会根据法律法规规定、诉讼争议解决需要，或按行政、司法机关依法提出的要求，对外共享您的个人信息。 <br />
                4、与关联公司共享：<strong><u>为便于我们基于</u></strong><strong><u>美得得</u></strong><strong><u>账户向您提供服务，推荐您可能感兴趣的信息或保护</u></strong><strong><u>美得得</u></strong><strong><u>关联公司或其他用户或公众的人身财产安全免遭侵害，您的个人信息可能会与我们的关联公司共享。</u></strong>我们只会共享必要的个人信息，且受本隐私政策中所声明目的的约束，如果我们共享您的个人敏感信息或关联公司改变个人信息的使用及处理目的，将再次征求您的授权同意。 <br />
                5、与授权合作伙伴共享：我们会委托授权合作伙伴为您提供某些服务或代表我们履行职能，我们仅会出于合法、正当、必要、特定、明确的目的共享您的信息，授权合作伙伴只能接触到为其履行职责所需信息，且不能将此信息用于任何其他目的。 <br />
                目前，我们的授权合作伙伴包括以下类型： <br />
                （1）<strong><u>使用我们SaaS软件的商家，使用我们的SaaS软件的商家为您商品或服务时，您提交的订单信息、支付信息、收货地址和联系人信息等，我们会使用我们SaaS软件的商家提供，以便于他们能完成您所需要的服务。如您不使用他们的服务，我们不会主动给任何一个商家提供您的任何个人信息。</u></strong><strong><u> </u></strong><br />
                （2）广告、分析服务类的授权合作伙伴。除非得到您的许可，否则我们不会将您的个人身份信息（指可以识别您身份的信息，例如姓名或电子邮箱，通过这些信息可以联系到您或识别您的身份）与提供广告、分析服务的合作伙伴共享。 <br />
                （3）供应商、服务提供商和其他合作伙伴。我们将信息发送给支持我们业务的供应商、服务提供商和其他合作伙伴，这些支持包括提供技术基础设施服务、分析我们服务的使用方式、衡量服务的有效性、提供客户服务、支付便利或进行学术研究和调查。 <br />
                   
                <strong><u> 对我们与之共享个人信息的公司、组织和个人，我们会与其签署严格的数据保护协议，要求他们按照我们的说明、本隐私政策以及其他任何相关的保密和安全措施来处理个人信息。</u></strong><strong><u> </u></strong><br />
                （二）转让 <br />
                我们不会将您的个人信息转让给任何公司、组织和个人，但以下情况除外： <br />
                1、在获取明确同意的情况下转让：获得您的明确同意后，我们会向其他方转让您的个人信息。 <br />
                2、在美得得服务提供者发生合并、收购或破产清算情形，或其他涉及合并、收购或破产清算情形时，如涉及到个人信息转让，我们会要求新的持有您个人信息的公司、组织继续受本政策的约束，否则我们将要求该公司、组织和个人重新向您征求授权同意。 <br />
                （三）公开披露 <br />
                我们仅会在以下情况下，公开披露您的个人信息： <br />
                1、获得您明确同意或基于您的主动选择，我们可能会公开披露您的个人信息； <br />
                2、<strong><u>如果我们确定您出现违反法律法规或严重违反</u></strong><strong><u>美得得</u></strong><strong><u>相关协议规则的情况，或为保护</u></strong><strong><u>美得得</u></strong><strong><u>及其关联公司用户或公众的人身财产安全免遭侵害，我们可能依据法律法规或</u></strong><strong><u>美得得</u></strong><strong><u>相关协议规则征得您同意的情况下披露关于您的个人信息，包括相关违规行为以及</u></strong><strong><u>美得得</u></strong><strong><u>已对您采取的措施。</u></strong>例如，若您销售假货而严重违反美得得规则，我们可能会公开披露您的店铺主体信息与处罚情况。 <br />
                （四）共享、转让、公开披露个人信息时事先征得授权同意的例外 <br />
                以下情形中，共享、转让、公开披露您的个人信息无需事先征得您的授权同意： <br />
                1、根据法律法规的规定或行政、司法机构、国家部门等有权机关的要求依法提供的； <br />
                2、出于维护您或其他个人的生命、财产等重大合法权益但又很难得到本人同意的； <br />
                3、您自行向社会公众公开的个人信息； <br />
                4、从合法公开披露的信息中收集个人信息的，如合法的新闻报道、政府信息公开等渠道。 <br />
                根据法律规定，共享、转让经去标识化处理的个人信息，且确保数据接收方无法复原并重新识别个人信息主体的，不属于个人信息的对外共享、转让及公开披露行为，对此类数据的保存及处理将无需另行向您通知并征得您的同意。 </div>
            <div>四、我们如何保护您的个人信息安全 <br />
                （一）为保障您的信息安全，我们努力采取各种符合业界标准的物理、电子和管理方面的安全措施来保护您的个人信息，防止您的个人信息遭到未经授权访问、公开披露、使用、修改、损坏或丢失。我们会采取一切合理可行的措施，保护您的个人信息。例如在您的浏览器与“服务”之间交换数据（如信用卡信息）时采用 SSL 加密保护技术；同时对网站本身提供 https 安全浏览方式；使用加密技术确保数据的保密性；使用受信赖的保护机制防止数据遭到恶意攻击；部署访问控制机制，确保只有授权人员才可访问个人信息；以及举办安全和隐私保护培训课程，加强员工对于保护个人信息重要性的认识。。 <br />
                （二）我们的安全系统，有专门的团队在负责，公司从人力财力上均有较大的投入，且我们的系统安全性已通过权威第三方的监测，并获得了ISO27001等认证。 <br />
                （三）我们会采取合理可行的措施，尽力避免收集无关的个人信息。<strong><u>我们只会在达成本政策所述目的所需的期限内保留您的个人信息，除非需要延长保留期或受到法律的允许。</u></strong> <br />
                （四）互联网并非绝对安全的环境，我们强烈建议您通过安全方式、使用复杂密码，协助我们保证您的账号安全。 <br />
                （五）在不幸发生个人信息安全事件后，我们将按照法律法规的要求向您告知：安全事件的基本情况和可能的影响、我们已采取或将要采取的处置措施、您可自主防范和降低风险的建议、对您的补救措施等。事件相关情况我们将以邮件、信函、电话、推送通知等方式告知您，难以逐一告知个人信息主体时，我们会采取合理、有效的方式发布公告。 <br />
                同时，我们还将按照监管部门要求，上报个人信息安全事件的处置情况。 </div>
            <div>五、您如何行使您的个人信息权利 <br />
                您对您的个人信息您享有以下权利： <br />
                （一）您有权访问您的个人信息，法律法规规定的例外情况除外。如果您想行使数据访问权，可以通过以下方式自行访问： <br />
                账户信息——如果您希望访问或编辑您的账户中的个人资料信息和支付信息、更改您的密码、添加安全信息或关闭您的账户等，您可以通过访问美得得网页执行此类操作。 <br />
                搜索信息——您可以在美得得网及相关网站中访问或清除您的搜索历史记录、查看和修改兴趣以及管理其他数据。 <br />
                如果您无法通过上述链接访问这些个人信息，您可以随时联系我们的客服。我们将在30天内回复您的访问请求。 <br />
                （二）您有权更正您的个人信息； <br />
                （三）<strong><u>您有权删除您的个人信息，您可以登录</u></strong><strong><u>美得得</u></strong><strong><u>账号，点击您需要注销账号，再您确认删除您的账号信息时，我们将删除您的信息，由此产生的您的权益或者资产同时消失的损失由您承担；</u></strong><strong><u> </u></strong><br />
                （四）您有权改变您授权同意的范围。 <br />
                以上信息您均可以通过美得得网站主页进行访问和更新。 <br />
                如果您认为美得得存在违反法律的规定收集、使用您个人信息的情形，您可以通过美得得客服与我们取得联系。 </div>
            <div>六、您的个人信息如何在全球范围转移 <br />
                我们在中华人民共和国境内运营中收集和产生的个人信息，存储在中国境内，以下情形除外： <br />
                1、法律法规有明确规定； <br />
                2、获得您的明确授权； <br />
                3、您通过互联网进行跨境交易等个人主动行为。 <br />
                针对以上情形，我们会确保依据本隐私政策对您的个人信息提供足够的保护。 </div>
            <div>七、我们如何处理儿童的个人信息 <br />
                <strong><u>本政策所指的儿童是指不满14周岁的个人，如果没有父母或监护人的同意，儿童不得创建自己的用户账户。如您为未成年人的，建议您请您的父母或监护人仔细阅读本隐私政策，并在征得您的父母或监护人同意的前提下使用我们的服务或向我们提供信息。对于经父母或监护人同意使用我们的产品或服务而收集未成年人个人信息的情况，我们只会在法律法规允许、父母或监护人明确同意或者保护未成年人所必要的情况下使用、共享、转让或披露此信息。</u></strong>如果我们发现自己在未事先获得可证实的父母同意的情况下收集了儿童的个人信息，则会设法尽快删除相关数据。 </div>
            <div>八、本隐私政策如何更新 <br />
                <strong><u>我们提供的服务和产品会不时更新和调整，隐私政策也将随之可能变更，如发生变更我们会以公示的方式进行通知到您，也不排除使用“弹框”或者邮件、短信等方式通知到您，请您及时查看最新的隐私政策。</u></strong><strong><u> </u></strong></div>
            <div>九、如何联系我们 <br />
                我们设立了个人信息保护部门，如对本政策内容有任何疑问、意见或建议，或发现您的个人信息可能被泄露，您可以电话到400-087-9077与我们联系，我们将在15天内回复您的请求 <br />
                如果您对我们的回复不满意，特别是您认为我们的个人信息处理行为损害了您的合法权益，您还可以通过被告住所地有管辖权的法院提起诉讼来寻求解决方案。 </div>

        </div>`;
let content_use = `<div>
    <div class="tac font16"><b>用户协议</b><br /></div><div><b>特别提示：</b></div></div>
<div>您在使用美得得科技（深圳）有限公司（以下简称“美得得”）及关联公司提供的各项服务之前，请您务必审慎阅读、充分理解本协议各条款内容，特别是以粗体标注的部分，包括但不限于免除或者限制责任的条款。如您不同意本服务协议及/或随时对其的修改，您应立即停止注册；您一旦使用美得得提供的服务，即视为您已了解并完全同意本服务协议各项内容，包括美得得对服务协议所做的修改，并成为我们的用户。</div>
<div><b>一、账号注册</b></div>
<div>1、您应当同意本协议的条款并按照页面上的提示完成全部的注册程序。您在进行注册程序或第三方授权登录程序过程中勾选协议即表示您与美得得达成协议，完全接受本协议项下的全部条款约束。</div>

<div>2、当您选择通过第三方授权登录程序进入美得得，您需授权美得得收集您的账号昵称及头像等标识化的个人信息，授权完成后，您即成为美得得的“用户”。</div>
&nbsp;&nbsp;&nbsp;&nbsp;当您按照注册页面提示填写信息并注册成功后，您即成为美得得的“用户”；美得得将给予您一个用户帐号，密码由您自行设置。该用户帐号和密码由您自行负责保管。</div>

<div>&nbsp;&nbsp;&nbsp;您应当对您在美得得进行的活动和事件负法律责任。</div>

<div>3、本协议服务条款和公告可由美得得定时更新，并按照法定流程进行公示。您在使用相关服务时,应关注并遵守其所适用的相关条款。</div>

<div>4、使用同一身份认证信息、同一手机号或经美得得排查认定多个美得得账户的实际控制人为同一人的，均视为同一用户。</div>

<div>5、您确认，在您开始使用本服务前，您应当具备中华人民共和国法律规定的与您行为相适应的民事行为能力。若您不具备前述与您行为相适应的民事行为能力，则您需要在您监护人的陪同下完成注册，并且您与您的监护人应依照法律规定承担因此而导致的一切后果。</div>

<div><b>二、注册信息和隐私保护</b></div>
1、您帐号的所有权归美得得，使用权归您。您按注册页面引导填写信息，阅读并同意本协议且完成全部注册程序后，即可获得注册账号并成为用户。您应提供及时、详尽及准确的个人资料，并不断更新注册资料，符合及时、详尽准确的要求。所有原始键入的资料将引用为注册资料。如果因注册信息不真实或更新不及时而引发的相关问题，由您自行承担相应的责任。</div>

<div>2、您应当通过真实身份信息认证注册帐号，且您提交的帐号名称、头像、&nbsp;简介等注册信息中不得出现违法和不良信息，经公司审核，如存在上述情况，美得得将不予注册；同时，在注册后，如发现您以虚假信息骗取帐号名称注册，或其帐号头像、简介等注册信息存在违法和不良信息的，美得得有权不经通知单方采取限期改正、暂停使用、注销登记、收回等措施。</div>

<div>3、您帐号包括帐户名称和密码，账户名称作为您有效的身份凭证之一。您可使用手机号和密码登录。</div>

<div>4、您不应将其帐号、密码转让、出售或出借予他人使用，若您授权他人使用帐户，应对被授权人在该帐户下发生所有行为负全部责任。由于您其他账户使用信息，仅当依法律法规、司法裁定或经美得得同意，并符合美得得规定的用户帐号转让流程的情况下，方可进行帐号的转让。</div>

<div>5、因您个人原因导致的帐号信息遗失，如需找回帐号信息，请按照帐号找回要求提供相应的信息，并确保提供的信息合法真实有效，若提供的信息不符合要求，无法通过安全验证，美得得有权拒绝提供帐号找回服务；若帐号的唯一凭证不再有效，美得得有权拒绝支持帐号找回。例如手机号二次出售，美得得可拒绝支持帮助找回原手机号绑定的帐号。</div>

<div>6、在需要终止使用帐号服务时，符合以下条件的，您可以申请注销您的帐号：</div>
<div>（1）您仅能申请注销您本人的帐号，并依照美得得的流程进行注销；</div>
<div>（2）您仍应对您在注销帐号前且使用的行为承担相应责任，同时美得得仍可保存您注销前的相关信息；</div>
<div>（3）注销成功后，帐号信息、个人身份信息、交易记录、会员权益等将无法恢复或提供。</div>
<div>7、当您使用美得得产品进行支付、登录等操作的时候，服务器会自动接收、验证、并记录一些必要的信息，如手机号码、IP地址、服务访问异常信息、以及部分设备信息等，以保障您在使用服务时账户登录和支付过程的安全，进而保护您的上网安全。您使用美得得的服务，即表示您同意美得得可以按照《隐私政策》处理您的个人信息。美得得可能会与合作伙伴共同向您提供您所要求的服务或者共同向您展示您可能感兴趣的内容。在信息为该项产品/服务所必须的情况下，您同意美得得可与其分享必要的信息。并且，美得得会要求其确保数据安全并且禁止用于任何其他用途。除此之外，美得得不会向任何无关第三方提供或分享信息。</div>

<div>8、您知悉并授权，美得得仅在必需的情况下使用或与关联公司同步您的信息，以为您提供更好的服务。</div>
<div>9、为更好地向您提供服务，您同意美得得通过短信、app通知等形式向您发送相关商业性服务信息。</div>

<div><b>三、使用规则</b></div>
<div>1、您在使用美得得的服务时，必须遵守中华人民共和国相关法律法规的规定，您应同意将不会利用本服务进行任何违法或不正当的活动，包括但不限于下列行为:</div>
<div>（1）您设置的会员名或提供的信息不得含有下列内容之一的信息：</div>
<div> &nbsp;①&nbsp;反对宪法所确定的基本原则的；</div>
<div>&nbsp;②&nbsp;危害国家安全，泄露国家秘密，颠覆国家政权，破坏国家统一的；</div>
<div>&nbsp;③&nbsp;损害国家荣誉和利益的；</div>
<div> &nbsp;④&nbsp;煽动民族仇恨、民族歧视、破坏民族团结的；</div>
<div> &nbsp;⑤&nbsp;破坏国家宗教政策，宣扬邪教和封建迷信的；</div>
<div>&nbsp;⑥&nbsp;散布谣言，扰乱社会秩序，破坏社会稳定的；</div>
<div> &nbsp;⑦&nbsp;散布淫秽、色情、赌博、暴力、凶杀、恐怖或者教唆犯罪的；</div>
<div> &nbsp;⑧&nbsp;侮辱或者诽谤他人，侵害他人合法权利的；</div>
<div> &nbsp;⑨&nbsp;含有虚假、有害、胁迫、侵害他人隐私、骚扰、侵害、中伤、粗俗、猥亵、或其它道德上令人反感的内容；</div>
<div>&nbsp;⑩&nbsp;含有中国法律、法规、规章、条例以及任何具有法律效力之规范所限制或禁止的其它内容的；</div>
<div>（2）不得为任何非法目的而使用美得得服务系统；</div>
<div>（3）不利用美得得的服务从事以下活动：</div>
<div>&nbsp;①&nbsp;未经允许，进入计算机信息网络或者使用计算机信息网络资源的；</div>
<div>&nbsp;②&nbsp;未经允许，对计算机信息网络功能进行删除、修改或者增加的；</div>
<div>&nbsp;③&nbsp;未经允许，对进入计算机信息网络中存储、处理或者传输的数据和应用程序进行删除、修改或者增加的；</div>
<div>&nbsp;④&nbsp;故意制作、传播计算机病毒等破坏性程序的；</div>
<div> &nbsp;⑤&nbsp;其他危害计算机信息网络安全的行为。</div>
<div>2、您违反本协议或相关的服务条款的规定，导致或产生的任何第三方主张的任何索赔、要求或损失，包括合理的律师费，您同意赔偿美得得与合作公司、关联公司，并使之免受损害。对此，美得得有权视您的行为性质，采取包括但不限于删除您发布信息内容、暂停使用许可、终止服务、限制使用、回收帐号、追究法律责任等措施。对恶意注册帐号或利用帐号进行违法活动、捣乱、骚扰、欺骗、其他用户以及其他违反本协议的行为，美得得有权回收其帐号。同时，美得得会视司法部门的要求，协助调查。</div>
<div>3、您需要对自己在服务使用过程中的行为负法律责任，即使您已经终止使用该服务。您承担法律责任的形式包括但不限于：对受到侵害者进行赔偿，以及在美得得首先承担了因您的行为导致的行政处罚或侵权损害赔偿责任后，您应给予美得得等额的赔偿。</div>
<div>4、美得得有权根据认定程序及标准判断您账户的使用可能危及您的账户安全及/或美得得平台信息安全的，美得得可拒绝提供相应服务或终止本协议。</div>
<div><b>四、服务内容</b></div>

<div>1、您在交易过程中与其他用户发生争议的，您或其他用户中任何一方可以自行协商解决，也可以通过美得得介入处理，若您觉得以上的方式均无法达到您要的结果，您可以寻求司法机关的协助。</div>

<div>2、您选择美得得介入的方式处理相关问题，那么您需要遵守和执行美得得的处理结果。若您对美得得的处理结果不满意，您可以寻求其他途径解决纠纷例如起诉、仲裁等方式，但在此之前您需先履行该结果。</div>

<div>3、美得得目前为您提供免费提供服务，但美得得保留因业务调整或者其他法律法规要求向您收取费用的权利。</div>

<div>4、美得得网络服务的具体内容由美得得根据实际情况提供。</div>
5、鉴于网络服务的特殊性，您同意美得得有权不经事先通知，随时变更、中断或终止部分或全部的网络服务（包括收费网络服务）。美得得不担保网络服务不会中断，对网络服务的及时性、安全性、准确性也都不作担保。</div>

<div>6、您需遵守美得得7天无理由退换货的相关规则。</div>

<div>7、终止服务</div>
您同意美得得得基于其自行之考虑，因任何理由，或美得得认为您已经违反本服务协议的文字及精神，终止您的密码、帐号或本服务之使用（或服务之任何部分），并将您在本服务内任何内容加以移除并删除。您同意依本服务协议任何规定提供之本服务，无需进行事先通知即可中断或终止，您承认并同意，美得得可立即关闭或删除您的帐号及您帐号中所有相关信息及文件，及/或禁止继续使用前述文件或本服务。此外，您同意若本服务之使用被中断或终止或您的帐号及相关信息和文件被关闭或删除，美得得对您或任何第三人均不承担任何责任。</div>

<div><b>五、个人数据保护与授权</b></div>

<div>1、为了保护您的财产及信息安全，预防诈骗或者其他网络犯罪行为，美得得有权收集您的个人信息，包括但不限于个人会员信息、交易信息来判断您个人的交易风险，对您身份进行验证等。</div>

<div>2、根据相关法律法规规定，以下情形中收集您的个人信息无需征得您的授权同意：</div>

<div>①、涉及公共安全，与重大利益相关的；</div>

<div>②、与政府部门包括司法机关等相关的；</div>

<div>③、出于保护您的个人财产或者利益的目的，但无法事先征求您同意的行为；</div>

<div>④、您以自行对外公开的，包括但不限于通过报纸、新闻等方式公开；</div>

<div>⑤、根据您的要求签订合同所必需的；</div>

<div>⑥、用于维护所提供的产品或服务的安全稳定运行所必需的，例如发现、处置产品或服务的故障；</div>

<div>⑦、国家法律法规政策认可或支持的相关行为；</div>

<div>3、我们已采取符合业界标准、合理可行的安全防护措施保护您提供的个人信息安全，防止个人信息遭到未经授权访问、公开披露、使用、修改、损坏或丢失。</div>
<div><b>六、免责声明</b></div>

<div>因以下情况造成网络服务在合理时间内的中断，美得得无需为此承担任何责任；</div>
<div>（1）美得得需要定期或不定期地对提供网络服务的平台或相关的设备进行检修或者维护，美得得保留不经事先通知为维修保养、升级或其它目的暂停本服务任何部分的权利。</div>
<div>（2）因台风、地震、洪水、雷电或恐怖袭击等不可抗力原因；</div>
<div>（3）您的电脑软硬件和通信线路、供电线路出现故障的；</div>
<div>（4）因病毒、木马、恶意程序攻击、网络拥堵、系统不稳定、系统或设备故障、通讯故障、电力故障、银行原因、第三方服务瑕疵或政府行为等原因。</div>
<div>尽管有前款约定，美得得将采取合理行动积极促使服务恢复正常。</div>

<div><b>七、知识产权和其他合法权益</b></div>
<div>1、美得得产品及相关网站上由美得得上传、制作、拥有的所有内容，包括但不限于著作、图片、档案、资讯、资料、网站架构、网站画面的安排、网页设计，均由美得得或其关联公司依法拥有其知识产权，包括但不限于商标权、专利权、著作权、商业秘密等。但如因您上传的由其自行制作、拥有的内容涉及侵犯美得得或其他任何第三方的合法权益的，您应自行对其侵权行为产生的纠纷进行处理，并对其侵权行为承担法律责任，且就由此给美得得造成的损失（包括但不限于美得得声誉的影响、美得得由此承担的连带责任（如有）等）进行赔偿。</div>

<div>2、非经美得得或其关联公司书面同意，任何人不得擅自使用、修改、复制、公开传播、改变、散布、发行或公开发表在本网站上程序或内容（仅限于由美得得上传、制作、拥有的所有内容，包括但不限于著作、图片、档案、资讯、资料、网站架构、网站画面的安排、网页设计等）；如您需使用著作权非美得得所有的内容的，您应获得具体内容的著作权所有者的合法授权才能使用，如因您私自使用非自己所有的、且未经他人合法授权的著作、图片、档案、资讯、资料等内容的，由您自行承担责任，包括但不限于您自行对其侵权行为产生的纠纷进行处理，并对其侵权行为承担法律责任，且就由此给乙方造成的损失（包括但不限于乙方声誉的影响、乙方由此承担的连带责任（如有）等）进行赔偿。</div>

<div>3、尊重知识产权是您应尽的义务，如有违反，您应承担损害赔偿责任。</div>

<div><b>八、其他</b></div>

<div>1、本协议之效力、解释、变更、执行与争议解决均适用中华人民共和国法律，没有相关法律规定的，参照通用国际商业惯例和（或）行业惯例。</div>

<div>2、&nbsp;如本协议的任何条款被视作无效或无法执行，则上述条款可被分离，其余条款则仍具有法律效力。</div>
<div>3、本协议任何一方于另一方过失或违约时放弃本协议规定的权利的，不得视为其对一方的其他或以后同类之过失或违约行为弃权。</div>

<div>4、美得得未行使或执行本服务协议任何权利或规定，不构成对前述权利或权利之放弃。</div>

<div>5、本协议最终解释权及修订权在法律范围内归美得得所有。</div>
    </div>`;

Page({

    /**
     * 页面的初始数据
     */
    data: {
        list: null,
        isLoading: false, // 检测是否已经发送请求,防止重复发送请求
        noMore: false, // 检测是否有更多数据,true为没有更多数据,false为还有数据
        pageNum: 1, // 当前页数
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        self = this;
        //-- 获取一下基础参数 --
        getApp().getConfig2(function (res) {
           if(res.reg_rule){ content_use=res.reg_rule; }
           if(res.reg_privacy){  content_privacy=res.reg_privacy; }

            let title = '';
            let content = '';
            if (options.t == 0) {
                title = '用户使用协议';
                content = content_use;
            } else if (options.t == 1) {
                title = '隐私政策';
                content = content_privacy;
            }
            ;
            wx.setNavigationBarTitle({
                title: title,
            });

            WxParse.wxParse('content', 'html', content, self);

        }, 1)

    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {
        getApp().check_can_share();
    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
     onShareAppMessage: function () {   	  getApp().globalData.no_clear=1

    },

    /**
     * get请求数据
     */
    get(url, data) {
        app.request.get(url + '/' + data.store_id, {
            success: function (res) {
                if (res.data.code == 0) {
                    console.log('success~~~~~~~~~~~', res);
                    self.setData({
                        content: res.data.data.distriRule,
                    });
                    /**
                     * WxParse.wxParse(bindName , type, data, target,imagePadding)
                     * 1.bindName绑定的数据名(必填)
                     * 2.type可以为html或者md(必填)
                     * 3.data为传入的具体数据(必填)
                     * 4.target为Page对象,一般为this(必填)
                     * 5.imagePadding为当图片自适应是左右的单一padding(默认为0,可选)
                     */
                    WxParse.wxParse('content', 'html', self.data.content, self);
                } else {
                    wx.showToast({
                        title: "网络繁忙，请重试",
                        icon: 'none',
                        duration: 2000
                    })
                }
            },
            fail: function () {
            },
        });
    },

})