var t = getApp(),
  a = t.request,
  o = t.globalData.setting,
  os = o,
  i = require("../../../utils/util.js"),
  ut = i,
  s = require("../../../utils/common.js");
var regeneratorRuntime = require('../../../utils/runtime.js');
var oo = t.globalData.setting,
  os = oo,
  ut = require("../../../utils/util.js");
Page({

  /**
   * 页面的初始数据
   */
  data: {
    url: os.url, //接口网址
    iurl: os.imghost, //图片前缀网址
    switch_head: 0, //0：我的任务，1：活动说明
    zl_act: null, //助力活动
    zl_user_list: [], //任务列表
    is_load: 0, //是否已经加载
    cur_page: 1, //页码
    page_num: 5, //每页多少个
    is_show_more: 0, //是否加载更多
    help_id: "", //助力活动的id
    timer: "", //任务列表的定时器
    s_num: "", //多少人已经领取任务
    page: 1, //我的任务的当前页

    imageUrl: '',
    btn_color: '',
    bg_color: '',
    font_color: '',
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    var th = this;
    var nav_b = th.selectComponent("#nav_b"); //组件的id
    nav_b.set_name("助力", "/pages/user/assistance/assistance");

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
      getApp().check_can_share();
    //--先判断会员状态--
    getApp().is_Single_page(this, function () {
      var user_info = getApp().globalData.userInfo;
      if (user_info == null || user_info.mobile == undefined || user_info.mobile == "" || user_info.mobile == null) {
        getApp().goto('/packageE/pages/togoin/togoin');
        return false;
      }
      // 助力活动
      this.assistance();
    })
  },

  print() {
    var user_id = getApp().globalData.user_id;
    var store_id = os.stoid;

    getApp().request.promiseGet("/api/weshop/marketing/help/act/judge", {
      data: {
        storeId: store_id,
        userId: user_id
      }
    }).then(res => {
      console.log('res', res);
    });
  },

  // 助力活动
  assistance() {
    var th = this;
    var user_id = getApp().globalData.user_id;
    var store_id = os.stoid;
    getApp().request.promiseGet("/api/weshop/marketing/help/act/judge", {
      isShowLoading: true,
      data: {
        storeId: store_id,
        userId: user_id
      }
    }).then(res => {
      if (res.data.code == 0) {
        var help_data = res.data.data;
        help_data.remark = help_data.remark.replace(/\<img/gi, '<img style="max-width:100%;height:auto;display：block"');
        th.setData({
          zl_act: help_data,
          help_id: help_data.id,
          btn_color: help_data.btn_color,
          bg_color: help_data.bg_color,
          font_color: help_data.font_color,
          imageUrl: help_data.imageUrl,
        });
        if (th.data.help_id != "" && th.data.help_id != null) {
          //我的任务
          th.get_list();
        }
        return getApp().request.promiseGet("/api/weshop/marketing/help/involve/help/act/people/count", {
          isShowLoading: true,
          data: {
            helpId: help_data.id,
            storeId: store_id
          }
        })
      } else
        getApp().my_warnning("暂无此活动或您不符合商家设置的会员参与对象，无法参与！", 0, th);
      return ut.null_promise();
    }).then(res => {
      if (res && res.data && res.data.code == 0)
        th.setData({
          s_num: res.data.data.countAll
        })
    })


  },

  //--点击获取用户任务列表--会员的任务列表
  get_list: function () {

    var th = this;
    var page = th.data.page;
    if (page == 1) th.data.zl_user_list = [];
    var help_id = this.data.help_id;
    var r = Math.random() * 100;
    t.request.get("/api/weshop/marketing/help/help/user/page", {
      isShowLoading: true,
      data: {
        userId: getApp().globalData.user_id,
        storeId: os.stoid,
        helpId: help_id,
        page: page,
        pageSize: 5,
        r: r,
      },
      success: function (res) {
        clearTimeout(th.data.timer);

        if (!th.data.is_load)
          th.setData({
            is_load: 1
          })
        if (res.data.code == 0) {
          var list = th.data.zl_user_list;
          //连接数组
          list = list.concat(res.data.data.pageData);
          th.setData({
            zl_user_list: list,
            is_load: 1,
          });
          if (res.data.data.total <= 5) {
            th.setData({
              is_show_more: 1
            })
          } else {
            var page = th.data.page + 1;
            th.setData({
              is_show_more: 0,
              page: page
            })
          }
        } else {
          //getApp().my_warnning(res.data.msg, 0, th);
          th.setData({
            is_show_more: 1,
            page: page
          })
        }

      }
    })
  },

  //-----跳转到领取礼包的页面------
  go_task: function () {
    var th = this;
    var help_id = th.data.help_id;
    if (!help_id) {
      getApp().my_warnning("暂无此活动或您不符合商家设置的会员参与对象，无法参与！", 0, th);
      return false;
    }

    getApp().goto("/pages/user/assistance/task_assistance?help_id=" + help_id);
  },
  switch_head: function (e) {
    var th = this;
    var index = e.currentTarget.dataset.index; //获取当前选择的是任务还是活动说明
    var switch_head = th.data.switch_head; //0任务，1活动说明
    if (index != switch_head) {
      th.setData({
        switch_head: index
      })
    }
  },

  //关闭导航
  close: function () {
    var th = this;
    var nav_b = th.selectComponent("#nav_b"); //组件的id
    nav_b.close_box();
  },

  // 领取礼包
  get_libao: function (e) {
    var help_id = e.currentTarget.dataset.help_id;//活动id
    var taskId = e.currentTarget.dataset.taskid;//任务id
    var id = e.currentTarget.dataset.id;//用于跳到礼包详情一键全部领取用的任务id
    getApp().goto("/pages/user/assistance/giftpacklist?help_id=" + help_id + "&is_libao=" + 1 + "&taskId=" + taskId + "&id=" + id);
  },

  //查看礼包id
  select_libao: function (e) {
    var orderSn = e.currentTarget.dataset.ordersn; //订单号
    getApp().goto("/pages/user/assistance/giftpacklist?orderSn=" + orderSn);
  },

  //---查看任务---
  go_to_task: function (e) {
    var help_id = this.data.help_id;
    var taskid = e.currentTarget.dataset.taskid;
    getApp().goto("/pages/user/assistance/task_assistance?help_id=" + help_id + "&taskid=" + taskid);
  },

  onShareAppMessage(res) {
      getApp().globalData.no_clear=1;
    if (res.from === 'button') {
      // 来自页面内转发按钮
      console.log(res.target)
    }
    return {
      // title: '自定义转发标题',
    }
  },

    onShareTimeline() {
        getApp().globalData.no_clear=1;
        var store_name = getApp().globalData.config ? getApp().globalData.config.store_name : '';
        if (!store_name)
            store_name = getApp().globalData.setting.appName;

        var user_id=getApp().globalData.user_id;
        if(!user_id) user_id=0;

        return {
            title: '好友助力-' + store_name,
            query: 'first_leader='+user_id
        }
    },

})
