var auth = require("../../../utils/auth.js"),
	rq = require("../../../utils/request.js");
var e = getApp(),
	app = e,
	s = e.globalData.setting,
	os = s,
	app_d = e.globalData;
var regeneratorRuntime = require('../../../utils/runtime.js');
const {
	barcode,
	qrcode
} = require('../../../utils/index.js');
var ut = require("../../../utils/util.js");
let self = null;

Page({
	/**
	 * 页面的初始数据
	 */
	data: {
		length: 150,
		iurl: s.imghost,
		defaultAvatar: s.imghost + "/miniapp/images/no-head.jpg",
		userInfo: null,
		toji: null, //统计相关
		txmon: 0,
		byquan: 0,
		yuer: 0,
		is_no_plus: 0,  //是否开通等级卡，或者体验等级卡
		currentPage: 1,
		recommend_list: [],
		tc_hide: true,
		sw_index: 0,
		qy_list: null,
		gradeId: null,
		is_init: 0,
		cz_val: 0,
		full_cz_val: 0,
		is_dengji: 0, //是不是等级
		is_banner: 0, //是不是有生日活动
		giftbagid: "", //生日活动的类型
		actId: "", //生日活动的id
		actImg: "",
		is_assistance: 0, //助力活动
		ad_img: "",
		usertop_ad: [],//会员顶部配置
		add_card_data: '',  //等级卡的内容
		getusercode_vailtime:10,//会员二维码时效
		hiddenCS: true,
		is_show_recommend:false,
		has_rj:0,
		rfmName:'成长值',
		is_close_chuzhi:0,
		brcode:'',
		showvipcode:false,
		pshow:0,

		is_show_yq:0, //是不是要显示邀请
		show_erm_u:1,//弹出框显示会员二维码
	},
	goto_nav: function (e) {
		var th = this;
		var url = e.currentTarget.dataset.url;

		//附件的门店不用判断会员
		var is_fj_store=  url.indexOf('store/index')>-1;

		if (th.data.userInfo != null || is_fj_store) {
             console.log('跳转');
			getApp().goto(url);
		} else {
			wx.navigateTo({
				url: '/packageE/pages/togoin/togoin',
			})
		}
	},
	/**
	 * 生命周期函数--监听页面加载
	 */
	onLoad: function (options) {
    wx.offCopyUrl()
		self = this;
		var th = this;
		getApp().request.get("/api/weshop/ad/page?pid=401&store_id=" + os.stoid, {
			data: {
				enabled: 1
			},
			success: function (res) {
				if (res.data.code == 0 && res.data.data && res.data.data.pageData && res.data.data.pageData.length) {
				  var item = res.data.data.pageData[0];
				  if (item)
				  {
					  th.setData({ usertop_ad:item });
						if (item.ad_code) th.setData({ ad_img: item.ad_code })
				  }
				}
			}
		})

        var first_leader = options.first_leader;
		if(first_leader){
            //--  user_id代过来免登录 --
            getApp().globalData.first_leader = first_leader;
            //调用接口判断是不是会员
            getApp().request.promiseGet("/api/weshop/shoppingGuide/get/" + os.stoid + "/" + first_leader, {}).then(res => {
                if (res.data.code == 0) {
                    getApp().globalData.guide_id = res.data.data.id;
					getApp().globalData.guide_pick_id= res.data.data.pickup_id
                }
            })


		}else{
          //  app.getUserFir();
		}
		this.init_user_tool()
	},

	/**
	 * 生命周期函数--监听页面显示
	 */
	onShow:function () {


		var _that=this;

		this.init_load()

		//-- 看一下隐私政策要不要显示 --
		var privacy_pop = this.selectComponent("#privacy_pop"); //组件的id
		if (privacy_pop) {
			privacy_pop.check_pri_show();
		}

		getApp().check_can_share(this);
		//看一下小程序是不是过期了
		getApp().getConfig2(function (config2) {
			if (config2 && config2.is_overdue == 1) {
				getApp().promiseGet("/store/storemoduleendtime/page?store_id=" + os.stoid + "&type=5", {}).then(res => {
					var o = res;
					if (o.data.code == 0) {
						var ob = { isout: 0, isbuy: 1 };
						var arr = o.data.data.pageData;
						var isbuy = 0;
						//----如果数组不为空----
						if (arr.length > 0) {
							arr.forEach(function (val, ind) {
								if (val.is_sy == 0 && val.type == 5) {
									isbuy = 1;
									var now = ut.gettimestamp();
									if (now > val.end_time) ob.isout = 1;
									return false;
								}
							})
						}
						ob.isbuy = isbuy;
						th.setappdata(ob);
					}
				})
			}

			if(config2 && config2.switch_list){
				  var conf=JSON.parse(config2.switch_list)
				  var is_close_chuzhi=conf.is_close_chuzhi;
				 _that.setData({is_close_chuzhi})

			}

		})

		//调用接口判断商家plus有没有过期
		rq.promiseGet("/store/storemoduleendtime/page?store_id=" + os.stoid + "&type=3", {}).then(res => {
			if (res.data.code == 0) {
				var arr = res.data.data.pageData;
				if (arr.length > 0) {
					var item = arr[0];
					if (item.is_sy == 0) {
						var now = Date.parse(new Date()); now = now / 1000;
						if (item.end_time < now) {
						    th.setData({ is_no_plus: 0 })
						}else{
						    th.setData({ is_no_plus: 1 })											
						}

					}else if(item.is_sy == 1){
						th.setData({ is_no_plus: 1 })
					}
				}
			}
		})
		var th = this;

		if (typeof this.getTabBar === 'function' && this.getTabBar()) {
			var index = getApp().getPageIndex(this);
			this.getTabBar().setData({
				active: index //数字是当前页面在tabbar的索引
			});
			//getApp().requestCardNum(this);
		}


		var stoid = app_d.setting.stoid;
		var s = this, th = s,
			need_money = 0,
			cur_g_num = 0;


		//先查看一下是不是系统会员
		getApp().waitfor_login(async ()=> {
			if (!getApp().globalData.user_id) {
				if(!this.data.is_show_yq){
					ut.new_user_go(os.stoid,  getApp().globalData.first_leader);
					this.data.is_show_yq=1; //只显示一次
				}
			}else{
				/*------会员登录------*/
				var e = getApp().globalData.userInfo;
				if (e != undefined && e != null && e.mobile) {

					if (e.card_field != '' && e.card_field != null && e.card_field != undefined && e.card_expiredate) {
						var now = ut.gettimestamp();
						var str = e.card_expiredate.replace(/-/g, '/');;
						var end = new Date(str);
						end = Date.parse(end) / 1000;
						if (now < end) {
							this.puls_user();
						}
					}



					if(this.data.has_rj==0){
						var portrait_req = {
							ApiName:'api.slimming.member.portrait',
							store_id: e.store_id,
							//StaffId: that.idd,
							vipid: e.erpvipid,
						};

						getApp().getConfig(()=>{
							var url = '/api/weshop/delphiapi/pageErpApi?accdb='+getApp().globalData.config.erpid;
							getApp().request.promiseGet(url, {
								data: portrait_req
							})
								.then((res) => {
									if (res.data.code == 0 && res.data.data  && res.data.data.pageData && res.data.data.pageData.length) {
										th.setData({has_rj:1})
									}else {
										th.setData({has_rj:-1})
									}

								})
						})


					}


					// 判断是否开启美业
					getApp().promiseGet('/api/weshop/store/getTabSys/' + os.stoid, {}).then(res => {
						if (res.data.code == 0) {
							th.setData({
								enableMeiye: res.data.data.EnableMeiye,
							});
						};
					});

					getApp().request.promiseGet("/api/weshop/plus/vip/mem/bership/list?" + "storeId=" + os.stoid, {}).then(res => {
						if (res.data.code == 0) {
							var plusCard = res.data.data;
							for (var i = 0; i < plusCard.length; i++) {
								if (!plusCard[i].IsStopBuy) { th.setData({ show_buy_plus: 1 }); break; }
							}
						}
					})


					this.birthday();
					this.is_assistance();

					s.setData({
						userInfo: e
					});

					//--查询会员权益是否成绩
					s.getVison()

					//-- 要调用接口，获取卡的钱 --
					var url = "/api/weshop/wxuser/getWxCardInfo?storeId=" + os.stoid + "&userId=" + e.user_id;
					rq.get(url, {
						isShowLoading: 0,
						success: function (su) {
							if (su.data.code == 0) {
								s.setData({
									add_card_data: su.data.data,
								});
							}
						}
					});

					/*-----统计-----*/
					rq.get("/api/weshop/order/waitlist", {
						isShowLoading: 0,
						data: {
							user_id: app_d.user_id,isdel:0
						},
						success: function (su) {
							s.setData({
								toji: su.data.data,
							});
						}
					})
					/*-----获取线下会员的预存款和优惠券的数量-----*/
					rq.get("/api/weshop/users/getinfo/" + os.stoid + "/" + e.user_id, {
						isShowLoading: 0,
						success: function (su) {
							if (su.data.code == 0 && su.data.data) {
								var data = su.data.data;
								if (!data) data = {};
								data.cashcount = parseInt(data.cashcount);
								s.setData({
									udata: data,
								});
							}

						}
					})
					/*-----获取会员提现金额-----*/
					rq.get("/api/weshop/withdrawals/summoney", {
						isShowLoading: 0,
						data: {
							user_id: e.user_id,
							store_id: os.stoid,
							status: 0
						},
						success: function (su) {
							if (su.data.code == 0) {
								var yuer = parseFloat(th.data.userInfo.user_money -
									th.data.userInfo.frozen_money - su.data.data.summoney).toFixed(2);
								th.setData({
									txmon: su.data.data.summoney,
									yuer: yuer
								});
							}
						}
					})

					/*-----获取会员包邮券的数量-----*/
					rq.get("/api/weshop/userfeemail/page", {
						isShowLoading: 0,
						data: {
							user_id: e.user_id,
							store_id: os.stoid,
							pageSize: 1,
							isuse: 0
						},
						success: function (su) {
							if (su.data.code == 0) {
								th.setData({
									byquan: parseInt(su.data.data.total)
								});
							}
						}
					});

					/*-----物流信息提醒-----*/
					rq.get('/api/weshop/order/countDadaOrder', {
						isShowLoading: 0,
						data: {
							user_id: e.user_id,
							store_id: os.stoid,
						},
						success: function (su) {
							if (su.data.code == 0) {
								th.setData({
									countDadaOrder: su.data.data
								});
							}
						}
					});




					//--初始化是否有打勾--
					getApp().request.get("/api/weshop/users/grade/vip/init/get", {
						data: {
							storeId: os.stoid
						},
						success: function (rs) {
							if (rs.data.code == 0 && rs.data.data.isBool) {
								th.setData({ is_init: 1 });
								/*-----获取会员权益列表-----*/
								rq.get("/api/weshop/users/grade/vipprivilegeinfo/page", {
									isShowLoading: 0,
									data: {
										storeId: os.stoid,
										pageSize: 100
									},
									success: async function (res) {

										//判断有没有值，没有值返回
										if (!ut.ajax_ok(res)) return false;

										var arr_data = res.data.data.pageData;
										var gid = null,
											g_qy_list = null,
											cz_vals = 0,
											need_money = 0,
											backClass = null,

											GradeName = '';

										//获取成长值
										await getApp().request.promiseGet("/api/weshop/users/grade/aftervipinfo/get", {
											data: {
												storeId: os.stoid,
												userId: app_d.user_id
											}
										}).then(res => {
											if (res.data.code == 0 && res.data.data) {
												gid = res.data.data.GradeId;
												var cz_val = res.data.data.GradeSum;
												cz_vals = parseInt(cz_val);
												GradeName = res.data.data.GradeName;
											}
											//th.setData({ cz_val: cz_vals, GradeName: res.data.data.GradeName, is_init: is_init, gradeId: gid});
										})
										var obj = {
											cz_val: cz_vals,
											GradeName: GradeName,
											gradeId: gid,
											is_grad_get: 1
										};

										//  获取最大值
										await getApp().request.promiseGet("/api/weshop/users/grade/vipgradeinfo/page", {
											data: {
												storeId: os.stoid
											}
										}).then(res => {
											if (res.data.data)
												backClass = res.data.data.pageData;
											if (backClass) {
												var full_cz_val = backClass[backClass.length - 1].BuyGradeSum;
												//th.setData({ full_cz_val: full_cz_val});
												obj.full_cz_val = full_cz_val
											}
										})

										//--会员权益中心页的修改--
										for (var i in backClass) {
											var im = backClass[i];
											if (cz_vals < im.BuyGradeSum && need_money == 0) {
												need_money = im.BuyGradeSum;
												obj.need_money = need_money;
												obj.nextGradeName=im.GradeName;
												break;
											}
										}

										//获取当前等级的特权
										await getApp().request.promiseGet("/api/weshop/users/grade/privilegeform/list/page", {
											data: {
												storeId: os.stoid,
												GradeId: gid,
												userId: app_d.user_id,
												pageSize: 100
											}
										}).then(res => {
											if (res.data.data)
												g_qy_list = res.data.data.pageData;
										});

										for (var i in arr_data) {
											var item = arr_data[i];
											var FromId = th.check_is_has_qy(item, g_qy_list);
											arr_data[i].ishas = 0;
											if (FromId) {
												arr_data[i].ishas = 1;
												arr_data[i].FromId = FromId;
											}
										}
										arr_data.sort(function (a, b) {
											return b.ishas - a.ishas
										})

										//4个4个一组
										var arr = new Array();
										for (var i = 0; i < arr_data.length; i += 4) {
											arr.push(arr_data.slice(i, i + 4));
										}
										//th.setData({ qy_list: arr, need_money: need_money});
										obj.qy_list = arr;
										th.setData(obj);
										obj.is_init=1;
										obj.old_qy_list = arr_data;
										th.setData({qy_data:obj})
									}
								})
							}
						}
					})

					/*-- 获取 --*/
					th.requestRecommend();

					var is_chat=0;
					await getApp().request.promiseGet("/api/weshop/recharge/storageRechargeDetail/get/"+os.stoid, {
					}).then(res => {
						if(res && res.data.code==0 && res.data.data){
							is_chat=1;
						}
					})

					/*-------系统是否开通等级卡，会员是等级卡-----*/
					getApp().getConfig2(function (e) {
						var t_swi = e.switch_list;
						if (t_swi) t_swi = JSON.parse(t_swi)
						if (t_swi) {

							//如果商家未开通在线客服的话
							if(t_swi.weapp_customertype==3 && !is_chat){
								json_dt_swi.weapp_customertype=0
							}

							th.setData({ sys_switch: t_swi });
							var user_tool = [];
							if (t_swi.usertool) user_tool = JSON.parse(t_swi.usertool);
							th.setData({ c_list: user_tool });
							if (t_swi.usercode_vailtime!=null && parseInt(t_swi.usercode_vailtime)>0)
							{
								th.setData({ getusercode_vailtime: t_swi.usercode_vailtime });
							}
						}

						if (parseInt(t_swi.rank_switch) == 2) {
							var userInfo = th.data.userInfo;
							if (userInfo.card_field != null && userInfo.card_field != undefined && userInfo.card_field != "") {
								var now = ut.gettimestamp();
								var str = userInfo.card_expiredate;
								var end = new Date(str);
								end = Date.parse(end) / 1000;
								//---判断是不是有过期---
								if (now < end) {
									th.setData({
										is_dengji: 1
									})
								} else {
									th.setData({
										is_dengji: 3
									})
								}
							} else {
								th.setData({
									is_dengji: 2
								})
							}
						}
					})
					//th.requestRecommend();
					/*--- 获取一下，会员要不要线上美顾 ---*/
					rq.get("/api/weshop/users/getAndUpdateUser/" + os.stoid + "/" + getApp().globalData.user_id, {
						success:function(src) {
							if(src.data.code==0){
								var u_data= src.data.data;
								if(u_data.staffId){
									getApp().get_guide_from_staff(u_data.staffId,function (guide){
										if(guide){
											th.setData({
												sh_meigu:1
											})
										}
									});

								}
							}
						}
					})

				}
			}

			//自定义组件一定要等到页面加载完了，才来调用selectComponnent
			setTimeout(function () {

				th.setData({ is_show_recommend:true })
				if (getApp().globalData.user_id) getApp().requestCardNum(th);
				var goods_list = th.selectComponent("#goods_recommend"); //组件的id

				if(goods_list){
					goods_list.init();
					goods_list.get_list();
				}

			}, 1200)


			setTimeout(()=>{
				th.setData({ pshow:1 })
			},500)
		})
  },

  //获取会员权益等级是否升级
  getVison(){
    let isRfm = wx.getStorageSync('isRfm')
    if (isRfm) {
      this.setData({
        rfmName:'综合分'
      })
    }else{
      rq.get(`/api/weshop/users/grade/vip/getSysPara?storeId=${os.stoid}&classInfo=IsUpRMF`, {    
        success:  (res)=>{
          console.log('会员权益等级升级查询-------');
          console.log(res);
          if (res.data.code == 0 && res.data.data && res.data.data.IsBool){
            this.setData({
              rfmName:'综合分'
            })
            wx.setStorageSync('isRfm', true)
          }
        }
      })
    }
  },

	//判断会员是后有改服务项目
	check_is_has_qy: function (item, g_qy_list) {
		if (!g_qy_list) return false;

		for (var i in g_qy_list) {
			var iter = g_qy_list[i];
			if (iter.FormId == item.Id) return g_qy_list[i].FormId;
		}
		return false;
	},

	/**
	 * 生命周期函数--监听页面隐藏
	 */
	onHide: function () {

	},
	setappdata: function (t) {
		var t = getApp().globalData.wxapp_buy_obj;
		if (t && t.isout == 1)
			wx.navigateTo({
				url: "/packageD/pages/error/error?msg=小程序已经过期",
			});
		if (t && t.isbuy == 0)
			wx.navigateTo({
				url: "/packageD/pages/error/error?msg=还未购买小程序",
			});
	},
  showtext:function(){
    this.setData({
      showvipcode:true
    })
  },
	/**
	 * 页面上拉触底事件的处理函数
	 */
	onReachBottom: function () {
		//!this.nomore && this.requestRecommend();
		//var e = getApp().globalData.userInfo;
		//if (e != undefined && e != null && e.mobile) {
			var goods_list = this.selectComponent("#goods_recommend"); //组件的id
			goods_list.init();
			setTimeout(function () {
				goods_list.get_list();
			}, 300)
		//}
	},

	/**
	 * 用户点击右上角分享
	 */
	onShareAppMessage: function () {
		getApp().globalData.no_clear = 1;
        var url = "/pages/user/index/index";
		var userInfo = getApp().globalData.userInfo;
        if (userInfo) {
            url += "?first_leader=" + getApp().globalData.user_id;
        }
        var title = "会员中心"
        //分享 
        if (getApp().globalData.config && getApp().globalData.config.store_name) {
            title = getApp().globalData.config.store_name;
        } else if (getApp().globalData.setting.appName) {
            title = getApp().globalData.setting.appName;
        }

        var ob = {
            title: title,path: url,
        };
        return ob;
	},

	//------卡片的显示和关闭--------
	show_tc: function () {
    var that=this;
    if (!this.data.userInfo) return false;
    var getnowtime;
    rq.get("/api/weshop/users/getServerTime", {    
      success: function (res) {
        if (res.data.code == 0)
        {
          getnowtime=res.data.data;
          if (!getnowtime)
          {
            getApp().showWarning("获取服务时间失败");
            return;
          }
          //base64_encode($user.mobile.'|'.date('Y-m-d H:i:s')
          var val = that.data.userInfo.mobile + "|" +getnowtime+"|"+that.data.getusercode_vailtime;
          val = "^" + ut.base64_encode(val);

          qrcode('qrcode', val, 350, 350, that);             
          barcode('barcode', that.data.userInfo.userQrcode, 480,140);
          that.setData({
            tc_hide: false,
            brcode:that.data.userInfo.userQrcode
          });
        } 
      }
    })
    
	},
	hide_tc: function () {
		this.setData({
			tc_hide: true,
		});
	},

	//--跳转到预存款页面--
	deposit: function () {
    if (!this.data.userInfo) 
    {
      this.gobindtel();
      return false;
    }
		wx.navigateTo({
			url: '/packageD/pages/user/deposit/deposit',
		})
	},
	//--跳转到余额页面--
	balance: function () {
    if (!this.data.userInfo)
    {
      this.gobindtel();
      return false;
    };
		wx.navigateTo({
			url: '/packageD/pages/user/member/menber',
		})
	},
	//--跳转到优惠券--
	coupon: function () {
		var th = this;
    if (!this.data.userInfo) 
    {
      this.gobindtel();
      return false;
    };
		//  th.sendsm();
		wx.navigateTo({
			url: '/packageD/pages/user/coupons/coupons',
		})
	},
	//--跳转到积分--
	integral: function () {
    if (!this.data.userInfo) 
    {
      this.gobindtel();
      return false;
    }
		wx.navigateTo({
			url: '/packageD/pages/user/integral/integral',
		})
	},
	//--跳到绑定页面--
	gobindtel: function () {
		wx.navigateTo({
			url: '/packageE/pages/togoin/togoin?is_reg=1',
		})
	},

	go_order: function (e) {
    if (!this.data.userInfo)
    {
      this.gobindtel();
      return false;
    };
		var url = e.currentTarget.dataset.url;
		wx.navigateTo({
			url: url,
		})

	},

	//--加载更多商品--
	requestRecommend: function () {
		var e = this,
			t = '/api/weshop/goods/page?page=' + e.data.currentPage;
		var th_recommend_list = e.data.recommend_list;
		getApp().request.get(t, {
			data: {
				is_mainshow: 1,
				isonsale: 1,
				is_recommend: 1,
				is_on_sale: 1,
				store_id: os.stoid,
				pageSize: 10
			},
			success: function (ee) {

				if(ut.ajax_ok(ee)) {
                    var recommend_list = ee.data.data.pageData;
                    if (recommend_list && recommend_list.length > 0) {
                        var dd = [...th_recommend_list, ...recommend_list];
                        e.setData({
                            recommend_list,
                            dd
                        });
                        e.data.currentPage++;
                    } else {
                        e.setData({
                            nomore: 1
                        });
                    }
                }
			}
		})
	},

	//--跳转到权益页面--
	go_qy: function () {
		if (!this.data.userInfo) return false;
		var url = "/packageG/pages/user/userqy/userqy";
		getApp().goto(url);
	},

	//--跳转到商品详情页面--
	go_goods: function (e) {
		var gid = e.currentTarget.dataset.gid;
		var url = "/pages/goods/goodsInfo/goodsInfo?goods_id=" + gid;
		getApp().goto(url);
	},

	click_next: function () {
		var index = this.data.sw_index;
		index++;
		if (index >= this.data.qy_list.length) return;
		this.setData({
			sw_index: index
		})
	},

	click_pre: function () {
		var index = this.data.sw_index;
		index--;
		if (index < 0) return;
		this.setData({
			sw_index: index
		})
	},

	onSli: function (e) {
		var that = this;
		that.setData({
			sw_index: e.detail.current
		})
	},

	//--权益使用--
	go_qy_url: function (e) {
		var th = this;
		var no = e.currentTarget.dataset.no;
		var ind = e.currentTarget.dataset.ind;
		var find = e.currentTarget.dataset.find;
		var item = th.data.qy_list[find][ind];
		if (item.ishas == undefined || !item.ishas) {
			var qt_txt = th.selectComponent("#pop_txt"); //组件的id
			var ob = {
				title: "温馨提示",
				content: "当前会员暂无此权益"
			};
			qt_txt.open(ob);
			return false;
		}

		var url = e.currentTarget.dataset.img;
		if (!url || url == "") {
			url = `/public/upload/userqy/quanbg.jpg`
		}
		switch (no) {
			case "01":
				getApp().goto("/packageB/pages/user/user_coupon/user_coupon?img=" +
					url + "&gradeId=" + th.data.gradeId + "&FormId=" + item.Id);
				break;
			case "02":
				getApp().goto("/packageE/pages/user/user_fw/user_fw?gradeId=" + th.data.gradeId + "&FormId=" + item.Id);
				break;
			case "03":
				getApp().goto("/packageH/pages/user/user_spsy/user_spsy?img=" +
					url + "&gradeId=" + th.data.gradeId + "&FormId=" + item.Id);
				break;
			case "10":
				getApp().request.get("/api/weshop/users/grade/vipprivilegelist/other/get", {
					data: {
						storeId: os.stoid,
						formId: item.Id,
						userId: getApp().globalData.user_id,
						gradeId: th.data.gradeId
					},
					success: function (res) {
						var val = res.data.data.Remark;
						var title = res.data.data.PrivilegeName;
						var qt_txt = th.selectComponent("#pop_txt"); //组件的id
						var ob = {
							title: title,
							content: val
						};
						qt_txt.open(ob);
					}
				})
				break;
		}
	},

	//跳转到链接
	goto: function (e) {
    console.log(e);
    console.log('跳转');
    var url = e.currentTarget.dataset.url;
    wx.navigateTo({ url: url }) 
		// getApp().goto(url);
	},

	//---------联系客服------------
	contactService: function () {
		getApp().com_call(this);
	},

	// 获取客服热线
	getTel() {
		return new Promise((resolve, reject) => {
			var self = this;
			var s = getApp();
			s.getConfig(function (t) {
				if (t.store_tel == undefined) {
					getApp().request.get("/api/weshop/store/get/" + os.stoid, {
						isShowLoading: 1,
						data: {},
						success: function (rs) {
							getApp().globalData.config = rs.data.data;
							if (rs.data.data.store_tel == null && rs.data.data.store_tel == undefined) {
								getApp().showWarning("商家未设置电话");
								return false;
							} else {
								self.setData({
									store_tel: rs.data.data.store_tel,
								});
								// s.confirmBox("客服热线：" + rs.data.data.store_tel);
							};

						}
					})
				} else {
					self.setData({
						store_tel: t.store_tel,
					});
					// s.confirmBox("客服热线：" + t.store_tel);
				}
				resolve();
			});
		});
	},


	go_info: function () {
		getApp().goto("/packageG/pages/user/userinfo/userinfo");
	},

	jump: function () {
    let isRfm = wx.getStorageSync('isRfm')
    //升级为RFM就不跳转成长值详情
    if (!isRfm) {
      getApp().goto("/packageE/pages/user/grow_value/grow_value")
    }

	},
	// 判断生日营销的页面是不是存在
	birthday: function () {

		var th = this;
		rq.get("/api/weshop/marketing/birthday/act/judge", {
			data: { storeId: os.stoid, userId: app_d.user_id },
			success: function (res) {

				var code = res.data.code;
				if (code == 0) {
					var giftbagid = res.data.data.giftBagId;
					var actId = res.data.data.id;
					var actImg = res.data.data.actImg;
					th.setData({ giftbagid: giftbagid, actId: actId, actImg: actImg, b_gift:{ giftbagid: giftbagid, actId: actId, actImg: actImg } });
					th.setData({ is_banner: 1 });
				}

			}
		})
	},
	clike_banne: function () {
		var th = this;
		var actId = th.data.actId;
		var giftbagid = th.data.giftbagid;

		if (actId != "" && giftbagid != "") {

			getApp().goto("/packageF/pages/giftpack/birthdaygift/birthdaygift?actId=" + actId + "&gifbagid=" + giftbagid + "&orderType=" + 3);
		} else {

			getApp().showWarning("请稍后重试");
		}
	},

	// 判断助力活动是不是存在
	is_assistance: function () {
		var th = this, r = Math.random() * 100;
		rq.get("/api/weshop/marketing/help/act/judge", {
			data: {
				storeId: os.stoid,
				userId: app_d.user_id,
				r: r,
			},
			success: function (res) {
				var code = res.data.code;
				if (code == 0) {
					th.setData({
						is_assistance: 1
					});
				} else {
					th.setData({
						is_assistance: 0
					});
				}

			}
		})
	},

	//导航跳转
	nav_goto: function (e) {
		var url = e.currentTarget.dataset.url;
		if (!url || url == '') return;
		if (url[0] != '/') url = '/' + url;
		getApp().goto(url);
	},

	//添加卡包
	addcard: function () {
		var res = this.data.add_card_data;
		if (!res) return false;

		var arr = new Array(6)
		arr[0] = res.code;
		arr[1] = res.timestamp;
		arr[2] = res.jsapiTicket;
		arr[3] = res.openid;
		arr[4] = res.cardid;
		arr[5] = res.nonceStr;
		var c = arr.sort();
		var newstr = "";
		for (var i = 0; i < c.length; i++) {
			newstr += c[i];
		}

		var sh1 = ut.sha1(newstr);
		wx.addCard({
			cardList: [
				{
					cardId: res.cardid,
					cardExt: '{"code": "' + res.code + '", "openid": "' + res.openid + '","timestamp": "' + res.timestamp + '","nonce_str":"' + res.nonceStr + '","outer_str":"web", "signature":"' + sh1 + '"}'
				}

			],
			success: function (res) { },
			cancel: function (res) { }
		});
	},

	//订阅消息提醒
	sendsm: function () {
		var template_id = "";
		rq.get("/api/wx/weappSendlist/page", {
			data: {
				store_id: os.stoid,
				typeid: "1020"
			},
			success: function (res) {
				if (res.data.code == 0 && res.data.data.pageData.length > 0) {
					template_id = res.data.data.pageData[0].template_id;
					// //授权订阅
					wx.requestSubscribeMessage({
						tmplIds: [template_id],
						success(res) {

						},
						fail(res) {

						}
					})
				}
			}
		})
	},

	con_weixin: function () {
		getApp().con_wx(this);
	},

	customer_chat: function () {
		getApp().customer_chat(0);
	},

	//初始话按钮图标
	init_user_tool: async function () {
		var d_list = null;
		//读取user_tool按钮图标
		await getApp().promiseGet("/api/weshop/userTool/page?pageSize=100&store_id=" + os.stoid, {
		}).then(res => {
			if (ut.ajax_ok(res)) {
				d_list = res.data.data.pageData;
			}
		})
		
		if (!d_list) return false;

		let t_map={};
            for (let i in d_list) {
			 let ite=d_list[i];
			 //专享礼包、移包到F包
			 if (ite.id==10)
			 {
				d_list[i]["weappurl"]="/packageF/pages/giftpack/mygiftpack/mygiftpack";
				d_list[i]["new_weappurl"]="/packageF/pages/giftpack/mygiftpack/mygiftpack";
			 }
			 if (ite.id==26)
			 {
				d_list[i]["weappurl"]="/pages/user/order_list/order_list?index=1";
				d_list[i]["new_weappurl"]="/pages/user/order_list/order_list?index=1";
			 }


		     t_map[ite.name]=ite.id+'';
		} 
		this.setData({
		   tool_map:t_map
		})


		//过滤掉分销关闭的
		let distribut_end_time = await getApp().user_tools_endTime(2);//过滤掉分销到期的
		await getApp().promiseGet("/api/weshop/storeDistribut/get/" + os.stoid, {}).then(rs => {
			if (rs.data.code == 0 || !rs.data.data) {
				var is_ok=1;

				if(!distribut_end_time){
					is_ok=0;
				}
				else if(!rs.data.data){
					is_ok=0;
				}else{
					var dis=rs.data.data;
					if(!dis || dis.switch == 0){
						is_ok=0;
					}
				}

				for (var i in d_list) {
					if (d_list[i].name == '我的分销' && !is_ok) {
						d_list.splice(i, 1);
					}
				}
			}
		})

		//判断有没有开AI测肤
		await getApp().promiseGet("/api/weshop/wx/weappSkin/get/" + os.stoid, {}).then(rs => {
			if (rs.data.code != 0 || !rs.data.data) {
				for (var i in d_list) {
					if (d_list[i].name == 'AI测肤') {
						d_list.splice(i, 1);
					}
				}
			}
		})
		this.setData({ user_tool: d_list });
	},


	click_contact: function () {
		getApp().globalData.no_clear = 1;
	},

	//打开客服操作菜单
	openCS() {
		// 判断会员状态
		let user_info = getApp().globalData.userInfo;
		if (user_info == null || user_info.mobile == undefined || user_info.mobile == '' || user_info.mobile == null) {
			wx.navigateTo({
				url: '/packageE/pages/togoin/togoin',
			})
			return false;
		};
		// csType/在线客服设置：
		// 0关闭（如果有设置热线电话，则显示拨打热线电话）、
		// 1小程序客服、
		// 2企业微信客服
		if (this.data.sys_switch) {
			let csType = this.data.sys_switch.weapp_customertype;
			if (csType == 0) {
				// 拨打电话号码
				this.contactService();
			} else {
				this.getTel()
					.then(() => {
						self.setData({
							hiddenCS: false,
						});
					});
			};
		};

	},

	//关闭客服操作菜单
	closeCS() {
		this.setData({
			hiddenCS: true,
		});
	},

	//-----Plus会员获取-----------
	puls_user: function() {
		var th = this;
		getApp().request.get("/api/weshop/plus/vip/mem/list", {
			data: {
				storeId: os.stoid,
				userId: getApp().globalData.user_id,
			},
			success: function(su) {

				if (su.data.code == 0) {
					var cardname = su.data.data[0].MemCardName;
					if(cardname.length>5) cardname=cardname.substring(0,5); //保留5个字
					th.setData({
						pulscardname: cardname
					});
				}
			}
		});
	},

	//同步初始加载
	async init_load() {
		var th = this;
		//因为营销版本的功能包含了自定义模板的功能，是同时的
		//读取全局是否有弄自定义模板
		await getApp().request.promiseGet("/api/weshop/store_module/gets/"+os.stoid+"/1/8", {1: 1}).then(res => {
			var data = res.data.data;
			if (data && data.length) {
				var temp_data = data[0];
				var t_arr = JSON.parse(temp_data.json_str);

				let obj={
					share_title: temp_data.page_title,
					template_arr: t_arr,
					isTemplate: 1,
					bgcolor_t: temp_data.bkcolor,
					pshow:1
				};

				//---如果有设定顶部的颜色的时候--
				if (temp_data.top_color && temp_data.top_color != 'null') {
					var top_w_color = "#ffffff";
					if (temp_data.top_word_color) {
						top_w_color = temp_data.top_word_color
					}
					wx.setNavigationBarColor({
						frontColor: top_w_color, // 必写项
						backgroundColor: temp_data.top_color, // 必写项
					})
					obj.topwColor=top_w_color;
					obj.topbgColor=temp_data.top_color;
				}

				th.setData(obj);

			}
		})
	},

	hide_u_ewm(){
        this.setData({show_erm_u:0})
	},
	show_u_ewm(){
		var th=this;

		var getnowtime;
		rq.get("/api/weshop/users/getServerTime", {
			success: function (res) {
				if (res.data.code == 0)
				{
					th.setData({show_erm_u:1})
					getnowtime=res.data.data;
					if (!getnowtime)
					{
						getApp().showWarning("获取服务时间失败");
						return;
					}
					//base64_encode($user.mobile.'|'.date('Y-m-d H:i:s')
					var val = th.data.userInfo.mobile + "|" +getnowtime+"|"+th.data.getusercode_vailtime;
					val = "^" + ut.base64_encode(val);

					qrcode('qrcode', val, 350, 350, th);


				}
			}
		})


	}





})
